# __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base > Class Template Reference

List of all members.

## Detailed Description

### template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>
class __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >

Definition at line 53 of file vstring.h.

## Public Types

- typedef _Alloc allocator_type
- typedef __gnu_cxx::__normal_iterator<
  const_pointer, __versa_string > const_iterator
- typedef _CharT_alloc_type::const_pointer const_pointer
- typedef _CharT_alloc_type::const_reference const_reference
- typedef std::reverse_iterator<
  const_iterator > const_reverse_iterator
- typedef _CharT_alloc_type::difference_type difference_type
- typedef __gnu_cxx::__normal_iterator<
  pointer, __versa_string > iterator
- typedef _CharT_alloc_type::pointer pointer
- typedef _CharT_alloc_type::reference reference
- typedef std::reverse_iterator<
  iterator > reverse_iterator
- typedef _CharT_alloc_type::size_type size_type
- typedef _Traits traits_type
- typedef _Traits::char_type value_type

## Public Member Functions

- template<class _InputIterator> __versa_string (_InputIterator __beg, _InputIterator __end, const _Alloc &__a=_Alloc())
- __versa_string (size_type __n, _CharT __c, const _Alloc &__a=_Alloc())
- __versa_string (const _CharT *__s, const _Alloc &__a=_Alloc())
- __versa_string (const _CharT *__s, size_type __n, const _Alloc &__a=_Alloc())
- __versa_string (const __versa_string &__str, size_type __pos, size_type __n, const _Alloc &__a)
- __versa_string (const __versa_string &__str, size_type __pos, size_type __n=npos)
- __versa_string (const __versa_string &__str)
- __versa_string (const _Alloc &__a)
- __versa_string ()
- template<class _InputIterator> __versa_string & append (_InputIterator __first, _InputIterator __last)
- __versa_string & append (size_type __n, _CharT __c)
- __versa_string & append (const _CharT *__s)
- __versa_string & append (const _CharT *__s, size_type __n)
- __versa_string & append (const __versa_string &__str, size_type __pos, size_type __n)
- __versa_string & append (const __versa_string &__str)
- template<class _InputIterator> __versa_string & assign (_InputIterator __first, _InputIterator __last)
- __versa_string & assign (size_type __n, _CharT __c)
- __versa_string & assign (const _CharT *__s)
- __versa_string & assign (const _CharT *__s, size_type __n)
- __versa_string & assign (const __versa_string &__str, size_type __pos, size_type __n)
- __versa_string & assign (const __versa_string &__str)
- reference at (size_type __n)
- const_reference at (size_type __n) const
- const_iterator begin () const
- iterator begin ()
- const _CharT * c_str () const
- size_type capacity () const
- void clear ()
- int compare (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2) const
- int compare (size_type __pos, size_type __n1, const _CharT *__s) const
- int compare (const _CharT *__s) const
- int compare (size_type __pos1, size_type __n1, const __versa_string &__str, size_type __pos2, size_type __n2) const
- int compare (size_type __pos, size_type __n, const __versa_string &__str) const
- int compare (const __versa_string &__str) const
- size_type copy (_CharT *__s, size_type __n, size_type __pos=0) const
- const _CharT * data () const
- bool empty () const
- const_iterator end () const
- iterator end ()
- iterator erase (iterator __first, iterator __last)
- iterator erase (iterator __position)
- __versa_string & erase (size_type __pos=0, size_type __n=npos)
- size_type find (_CharT __c, size_type __pos=0) const
- size_type find (const _CharT *__s, size_type __pos=0) const
- size_type find (const __versa_string &__str, size_type __pos=0) const
- size_type find (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_first_not_of (_CharT __c, size_type __pos=0) const
- size_type find_first_not_of (const _CharT *__s, size_type __pos=0) const
- size_type find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_first_not_of (const __versa_string &__str, size_type __pos=0) const
- size_type find_first_of (_CharT __c, size_type __pos=0) const
- size_type find_first_of (const _CharT *__s, size_type __pos=0) const
- size_type find_first_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_first_of (const __versa_string &__str, size_type __pos=0) const
- size_type find_last_not_of (_CharT __c, size_type __pos=npos) const
- size_type find_last_not_of (const _CharT *__s, size_type __pos=npos) const
- size_type find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_last_not_of (const __versa_string &__str, size_type __pos=npos) const
- size_type find_last_of (_CharT __c, size_type __pos=npos) const
- size_type find_last_of (const _CharT *__s, size_type __pos=npos) const
- size_type find_last_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_last_of (const __versa_string &__str, size_type __pos=npos) const
- allocator_type get_allocator () const
- iterator insert (iterator __p, _CharT __c)
- __versa_string & insert (size_type __pos, size_type __n, _CharT __c)
- __versa_string & insert (size_type __pos, const _CharT *__s)
- __versa_string & insert (size_type __pos, const _CharT *__s, size_type __n)
- __versa_string & insert (size_type __pos1, const __versa_string &__str, size_type __pos2, size_type __n)
- __versa_string & insert (size_type __pos1, const __versa_string &__str)
- template<class _InputIterator> void insert (iterator __p, _InputIterator __beg, _InputIterator __end)
- void insert (iterator __p, size_type __n, _CharT __c)
- size_type length () const
- size_type max_size () const
- __versa_string & operator+= (_CharT __c)
- __versa_string & operator+= (const _CharT *__s)
- __versa_string & operator+= (const __versa_string &__str)
- __versa_string & operator= (_CharT __c)
- __versa_string & operator= (const _CharT *__s)
- __versa_string & operator= (const __versa_string &__str)
- reference operator[] (size_type __pos)
- const_reference operator[] (size_type __pos) const
- void push_back (_CharT __c)
- const_reverse_iterator rbegin () const
- reverse_iterator rbegin ()
- const_reverse_iterator rend () const
- reverse_iterator rend ()
- __versa_string & replace (iterator __i1, iterator __i2, const_iterator __k1, const_iterator __k2)
- __versa_string & replace (iterator __i1, iterator __i2, iterator __k1, iterator __k2)
- __versa_string & replace (iterator __i1, iterator __i2, const _CharT *__k1, const _CharT *__k2)
- __versa_string & replace (iterator __i1, iterator __i2, _CharT *__k1, _CharT *__k2)
- template<class _InputIterator> __versa_string & replace (iterator __i1, iterator __i2, _InputIterator __k1, _InputIterator __k2)
- __versa_string & replace (iterator __i1, iterator __i2, size_type __n, _CharT __c)
- __versa_string & replace (iterator __i1, iterator __i2, const _CharT *__s)
- __versa_string & replace (iterator __i1, iterator __i2, const _CharT *__s, size_type __n)
- __versa_string & replace (iterator __i1, iterator __i2, const __versa_string &__str)
- __versa_string & replace (size_type __pos, size_type __n1, size_type __n2, _CharT __c)
- __versa_string & replace (size_type __pos, size_type __n1, const _CharT *__s)
- __versa_string & replace (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2)
- __versa_string & replace (size_type __pos1, size_type __n1, const __versa_string &__str, size_type __pos2, size_type __n2)
- __versa_string & replace (size_type __pos, size_type __n, const __versa_string &__str)
- void reserve (size_type __res_arg=0)
- void resize (size_type __n)
- void resize (size_type __n, _CharT __c)
- size_type rfind (_CharT __c, size_type __pos=npos) const
- size_type rfind (const _CharT *__s, size_type __pos=npos) const
- size_type rfind (const _CharT *__s, size_type __pos, size_type __n) const
- size_type rfind (const __versa_string &__str, size_type __pos=npos) const
- size_type size () const
- __versa_string substr (size_type __pos=0, size_type __n=npos) const
- void swap (__versa_string &__s)
- ~__versa_string ()

## Static Public Attributes

- static const size_type npos

## Constructor & Destructor Documentation

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::__versa_string | ( |  | ) | `[inline]`

Default constructor creates an empty string.

Definition at line 131 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::__versa_string | ( | const _Alloc & | __a | ) | `[inline, explicit]`

Construct an empty string using allocator a.

Definition at line 138 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::__versa_string | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str | ) | `[inline]`

Construct string with copy of value of str.

Parameters:

  | str | Source string.

Definition at line 146 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::__versa_string | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos,
|  | size_type | __n = `npos` |
| ) |  |  | `[inline]`

Construct string as copy of a substring.

Parameters:

  | str | Source string.
  | pos | Index of first character to copy from.
  | n | Number of characters to copy (default remainder).

Definition at line 155 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::__versa_string | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos,
|  | size_type | __n,
|  | const _Alloc & | __a |
| ) |  |  | `[inline]`

Construct string as copy of a substring.

Parameters:

  | str | Source string.
  | pos | Index of first character to copy from.
  | n | Number of characters to copy.
  | a | Allocator to use.

Definition at line 170 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::__versa_string | ( | const _CharT * | __s,
|  | size_type | __n,
|  | const _Alloc & | __a = `_Alloc()` |
| ) |  |  | `[inline]`

Construct string initialized by a character array.

Parameters:

  | s | Source character array.
  | n | Number of characters to copy.
  | a | Allocator to use (default is default allocator).

NB: s must have at least n characters, '' has no special meaning.

Definition at line 187 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::__versa_string | ( | const _CharT * | __s,
|  | const _Alloc & | __a = `_Alloc()` |
| ) |  |  | `[inline]`

Construct string as copy of a C string.

Parameters:

  | s | Source C string.
  | a | Allocator to use (default is default allocator).

Definition at line 196 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::__versa_string | ( | size_type | __n,
|  | _CharT | __c,
|  | const _Alloc & | __a = `_Alloc()` |
| ) |  |  | `[inline]`

Construct string as multiple characters.

Parameters:

  | n | Number of characters.
  | c | Character to use.
  | a | Allocator to use (default is default allocator).

Definition at line 206 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>
template<class _InputIterator>

__gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::__versa_string | ( | _InputIterator | __beg,
|  | _InputIterator | __end,
|  | const _Alloc & | __a = `_Alloc()` |
| ) |  |  | `[inline]`

Construct string as copy of a range.

Parameters:

  | beg | Start of range.
  | end | End of range.
  | a | Allocator to use (default is default allocator).

Definition at line 216 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::~__versa_string | ( |  | ) | `[inline]`

Destroy the string instance.

Definition at line 223 of file vstring.h.

## Member Function Documentation

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>
template<class _InputIterator>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::append | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Append a range of characters.

Parameters:

  | first | Iterator referencing the first character to append.
  | last | Iterator marking the end of the range.

Returns:
  Reference to this string.

Appends characters in the range [first,last) to this string.

Definition at line 604 of file vstring.h.

References std::replace().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::append | ( | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Append multiple characters.

Parameters:

  | n | The number of characters to append.
  | c | The character to use.

Returns:
  Reference to this string.

Appends n copies of c to this string.

Definition at line 591 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::append | ( | const _CharT * | __s | ) | `[inline]`

Append a C string.

Parameters:

  | s | The C string to append.

Returns:
  Reference to this string.

Definition at line 574 of file vstring.h.

References __glibcxx_requires_string.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::append | ( | const _CharT * | __s,
|  | size_type | __n |
| ) |  |  | `[inline]`

Append a C substring.

Parameters:

  | s | The C string to append.
  | n | The number of characters to append.

Returns:
  Reference to this string.

Definition at line 561 of file vstring.h.

References __glibcxx_requires_string_len.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::append | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | `[inline]`

Append a substring.

Parameters:

  | str | The string to append.
  | pos | Index of the first character of str to append.
  | n | The number of characters to append.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | if pos is not a valid index.

This function appends n characters from str starting at pos to this string. If n is is larger than the number of available characters in str, the remainder of str is appended.

Definition at line 549 of file vstring.h.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::_M_check(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::_M_limit().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::append | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str | ) | `[inline]`

Append a string to this string.

Parameters:

  | str | The string to append.

Returns:
  Reference to this string.

Definition at line 533 of file vstring.h.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

Referenced by std::getline(), and __gnu_cxx::operator+().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>
template<class _InputIterator>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Set value to a range of characters.

Parameters:

  | first | Iterator referencing the first character to append.
  | last | Iterator marking the end of the range.

Returns:
  Reference to this string.

Sets value of string to characters in the range [first,last).

Definition at line 708 of file vstring.h.

References std::replace().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::assign | ( | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Set value to multiple characters.

Parameters:

  | n | Length of the resulting string.
  | c | The character to use.

Returns:
  Reference to this string.

This function sets the value of this string to n copies of character c.

Definition at line 695 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::assign | ( | const _CharT * | __s | ) | `[inline]`

Set value to contents of a C string.

Parameters:

  | s | The C string to use.

Returns:
  Reference to this string.

This function sets the value of this string to the value of s. The data is copied, so there is no dependence on s once the function returns.

Definition at line 678 of file vstring.h.

References __glibcxx_requires_string.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::assign | ( | const _CharT * | __s,
|  | size_type | __n |
| ) |  |  | `[inline]`

Set value to a C substring.

Parameters:

  | s | The C string to use.
  | n | Number of characters to use.

Returns:
  Reference to this string.

This function sets the value of this string to the first n characters of s. If n is is larger than the number of available characters in s, the remainder of s is used.

Definition at line 662 of file vstring.h.

References __glibcxx_requires_string_len.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::assign | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | `[inline]`

Set value to a substring of a string.

Parameters:

  | str | The string to use.
  | pos | Index of the first character of str.
  | n | Number of characters to use.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | if pos is not a valid index.

This function sets this string to the substring of str consisting of n characters at pos. If n is is larger than the number of available characters in str, the remainder of str is used.

Definition at line 646 of file vstring.h.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::_M_check(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::_M_limit().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::assign | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str | ) | `[inline]`

Set value to contents of another string.

Parameters:

  | str | Source string to use.

Returns:
  Reference to this string.

Definition at line 627 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

reference __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::at | ( | size_type | __n | ) | `[inline]`

Provides access to the data contained in the string.

Parameters:

  | n | The index of the character to access.

Returns:
  Read/write reference to the character.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails. Success results in unsharing the string.

Definition at line 488 of file vstring.h.

References __N.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

const_reference __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::at | ( | size_type | __n | ) | const`[inline]`

Provides access to the data contained in the string.

Parameters:

  | n | The index of the character to access.

Returns:
  Read-only (const) reference to the character.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 469 of file vstring.h.

References __N.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

const_iterator __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::begin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the first character in the string.

Definition at line 272 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

iterator __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::begin | ( |  | ) | `[inline]`

Returns a read/write iterator that points to the first character in the string. Unshares the string.

Definition at line 261 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

const _CharT* __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::c_str | ( |  | ) | const`[inline]`

Return const pointer to null-terminated contents.

This is a handle to internal data. Do not modify or dire things may happen.

Definition at line 1257 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::capacity | ( |  | ) | const`[inline]`

Returns the total number of characters that the string can hold before needing to allocate more memory.

Definition at line 381 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

void __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::clear | ( |  | ) | `[inline]`

Erases the string, making it empty.

Definition at line 409 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

int __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 |
| ) |  |  | const

Compare substring against a character array.

Parameters:

  | pos1 | Index of first character of substring.
  | n1 | Number of characters in substring.
  | s | character array to compare against.
  | n2 | Number of characters of s.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n1 characters starting at pos1. Form a string from the first n2 characters of s. Returns an integer < 0 if this substring is ordered before the string from s, 0 if their values are equivalent, or > 0 if this substring is ordered after the string from s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and n2. The function then compares the two strings by calling traits::compare(substring.data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

NB: s must have at least n2 characters, '' has no special meaning.

Definition at line 530 of file vstring.tcc.

References __glibcxx_requires_string_len, and std::min().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

int __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s |
| ) |  |  | const

Compare substring to a C string.

Parameters:

  | pos | Index of first character of substring.
  | n1 | Number of characters in substring.
  | s | C string to compare against.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n1 characters starting at pos. Returns an integer < 0 if the substring is ordered before s, 0 if their values are equivalent, or > 0 if the substring is ordered after s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and the length of a string constructed from s. The function then compares the two string by calling traits::compare(substring.data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 513 of file vstring.tcc.

References __glibcxx_requires_string, and std::min().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

int __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::compare | ( | const _CharT * | __s | ) | const

Compare to a C string.

Parameters:

  | s | C string to compare against.

Returns:
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before s, 0 if their values are equivalent, or > 0 if this string is ordered after s. Determines the effective length rlen of the strings to compare as the smallest of size() and the length of a string constructed from s. The function then compares the two strings by calling traits::compare(data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 497 of file vstring.tcc.

References __glibcxx_requires_string, std::min(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

int __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 |
| ) |  |  | const

Compare substring to a substring.

Parameters:

  | pos1 | Index of first character of substring.
  | n1 | Number of characters in substring.
  | str | String to compare against.
  | pos2 | Index of first character of substring of str.
  | n2 | Number of characters in substring of str.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n1 characters starting at pos1. Form the substring of str from the n2 characters starting at pos2. Returns an integer < 0 if this substring is ordered before the substring of str, 0 if their values are equivalent, or > 0 if this substring is ordered after the substring of str. Determines the effective length rlen of the strings to compare as the smallest of the lengths of the substrings. The function then compares the two strings by calling traits::compare(substring.data(),str.substr(pos2,n2).data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 478 of file vstring.tcc.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::_M_check(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::_M_limit(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::data(), and std::min().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

int __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::compare | ( | size_type | __pos,
|  | size_type | __n,
|  | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str |
| ) |  |  | const

Compare substring to a string.

Parameters:

  | pos | Index of first character of substring.
  | n | Number of characters in substring.
  | str | String to compare against.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n characters starting at pos. Returns an integer < 0 if the substring is ordered before str, 0 if their values are equivalent, or > 0 if the substring is ordered after str. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and str.size(). The function then compares the two strings by calling traits::compare(substring.data(),str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 461 of file vstring.tcc.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::data(), std::min(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

int __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::compare | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str | ) | const`[inline]`

Compare to a string.

Parameters:

  | str | String to compare against.

Returns:
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before str, 0 if their values are equivalent, or > 0 if this string is ordered after str. Determines the effective length rlen of the strings to compare as the smallest of size() and str.size(). The function then compares the two strings by calling traits::compare(data(), str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 1667 of file vstring.h.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::data(), std::min(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

Referenced by __gnu_cxx::operator!=(), __gnu_cxx::operator<(), __gnu_cxx::operator<=(), __gnu_cxx::operator==(), __gnu_cxx::operator>(), and __gnu_cxx::operator>=().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string< _CharT, _Traits, _Alloc, _Base >::size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::copy | ( | _CharT * | __s,
|  | size_type | __n,
|  | size_type | __pos = `0` |
| ) |  |  | const

Copy substring into C string.

Parameters:

  | s | C string to copy value into.
  | n | Number of characters to copy.
  | pos | Index of first character to copy.

Returns:
  Number of characters actually copied

Exceptions:

  | std::out_of_range | If pos > size().

Copies up to n characters starting at pos into the C string s. If pos is greater than size(), out_of_range is thrown.

Definition at line 256 of file vstring.tcc.

References __glibcxx_requires_string_len.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

const _CharT* __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::data | ( |  | ) | const`[inline]`

Return const pointer to contents.

This is a handle to internal data. Do not modify or dire things may happen.

Definition at line 1267 of file vstring.h.

Referenced by __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::compare(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_not_of(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_of(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_not_of(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_of(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::rfind().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

bool __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::empty | ( |  | ) | const`[inline]`

Returns true if the string is empty. Equivalent to *this == "".

Definition at line 416 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

const_iterator __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::end | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points one past the last character in the string.

Definition at line 291 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

iterator __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::end | ( |  | ) | `[inline]`

Returns a read/write iterator that points one past the last character in the string. Unshares the string.

Definition at line 280 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

iterator __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::erase | ( | iterator | __first,
|  | iterator | __last |
| ) |  |  | `[inline]`

Remove a range of characters.

Parameters:

  | first | Iterator referencing the first character to remove.
  | last | Iterator referencing the end of the range.

Returns:
  Iterator referencing location of first after removal.

Removes the characters in the range [first,last) from this string. The value of the string doesn't change if an error is thrown.

Definition at line 921 of file vstring.h.

References _GLIBCXX_DEBUG_PEDASSERT.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

iterator __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::erase | ( | iterator | __position | ) | `[inline]`

Remove one character.

Parameters:

  | position | Iterator referencing the character to remove.

Returns:
  iterator referencing same location after removal.

Removes the character at position from this string. The value of the string doesn't change if an error is thrown.

Definition at line 901 of file vstring.h.

References _GLIBCXX_DEBUG_PEDASSERT.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::erase | ( | size_type | __pos = `0`,
|  | size_type | __n = `npos` |
| ) |  |  | `[inline]`

Remove characters.

Parameters:

  | pos | Index of first character to remove (default 0).
  | n | Number of characters to remove (default remainder).

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos is beyond the end of this string.

Removes n characters from this string starting at pos. The length of the string is reduced by n. If there are < n characters to remove, the remainder of the string is truncated. If p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 885 of file vstring.h.

Referenced by std::getline().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string< _CharT, _Traits, _Alloc, _Base >::size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find | ( | _CharT | __c,
|  | size_type | __pos = `0` |
| ) |  |  | const

Find position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 295 of file vstring.tcc.

References std::find(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::npos, and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find | ( | const _CharT * | __s,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a C string.

Parameters:

  | s | C string to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of start of first occurrence.

Starting from pos, searches forward for the value of s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1316 of file vstring.h.

References __glibcxx_requires_string, and std::find().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a string.

Parameters:

  | str | String to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of start of first occurrence.

Starting from pos, searches forward for value of str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1302 of file vstring.h.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::data(), std::find(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string< _CharT, _Traits, _Alloc, _Base >::size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const

Find position of a C substring.

Parameters:

  | s | C string to locate.
  | pos | Index of character to search from.
  | n | Number of characters from s to search for.

Returns:
  Index of start of first occurrence.

Starting from pos, searches forward for the first n characters in s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 271 of file vstring.tcc.

References __glibcxx_requires_string_len, __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::npos, and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string< _CharT, _Traits, _Alloc, _Base >::size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_not_of | ( | _CharT | __c,
|  | size_type | __pos = `0` |
| ) |  |  | const

Find position of a different character.

Parameters:

  | c | Character to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character other than c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 406 of file vstring.tcc.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::npos, and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a character not in C string.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character not contained in s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1555 of file vstring.h.

References __glibcxx_requires_string.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string< _CharT, _Traits, _Alloc, _Base >::size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const

Find position of a character not in C substring.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search from.
  | n | Number of characters from s to consider.

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character not contained in the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 393 of file vstring.tcc.

References __glibcxx_requires_string_len, std::find(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::npos, and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_not_of | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a character not in string.

Parameters:

  | str | String containing characters to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character not contained in str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1526 of file vstring.h.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::data(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_of | ( | _CharT | __c,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for the character c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to find(c, pos).

Definition at line 1451 of file vstring.h.

References std::find().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a character of C string.

Parameters:

  | s | String containing characters to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for one of the characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1432 of file vstring.h.

References __glibcxx_requires_string, and std::find_first_of().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string< _CharT, _Traits, _Alloc, _Base >::size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const

Find position of a character of C substring.

Parameters:

  | s | String containing characters to locate.
  | pos | Index of character to search from.
  | n | Number of characters from s to search for.

Returns:
  Index of first occurrence.

Starting from pos, searches forward for one of the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 354 of file vstring.tcc.

References __glibcxx_requires_string_len, std::find(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::npos, and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_of | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline]`

Find position of a character of string.

Parameters:

  | str | String containing characters to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for one of the characters of str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1404 of file vstring.h.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::data(), std::find_first_of(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string< _CharT, _Traits, _Alloc, _Base >::size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_not_of | ( | _CharT | __c,
|  | size_type | __pos = `npos` |
| ) |  |  | const

Find last position of a different character.

Parameters:

  | c | Character to avoid.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for a character other than c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 440 of file vstring.tcc.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::npos, and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a character not in C string.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for a character not contained in s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1615 of file vstring.h.

References __glibcxx_requires_string.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string< _CharT, _Traits, _Alloc, _Base >::size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const

Find last position of a character not in C substring.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search back from.
  | n | Number of characters from s to consider.

Returns:
  Index of last occurrence.

Starting from pos, searches backward for a character not contained in the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 418 of file vstring.tcc.

References __glibcxx_requires_string_len, std::find(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::npos, and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_not_of | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a character not in string.

Parameters:

  | str | String containing characters to avoid.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for a character not contained in str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1585 of file vstring.h.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::data(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_of | ( | _CharT | __c,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to rfind(c, pos).

Definition at line 1512 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a character of C string.

Parameters:

  | s | C string containing characters to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for one of the characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1493 of file vstring.h.

References __glibcxx_requires_string.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string< _CharT, _Traits, _Alloc, _Base >::size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const

Find last position of a character of C substring.

Parameters:

  | s | C string containing characters to locate.
  | pos | Index of character to search back from.
  | n | Number of characters from s to search for.

Returns:
  Index of last occurrence.

Starting from pos, searches backward for one of the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 371 of file vstring.tcc.

References __glibcxx_requires_string_len, std::find(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::npos, and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_of | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a character of string.

Parameters:

  | str | String containing characters to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for one of the characters of str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1465 of file vstring.h.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::data(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

allocator_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::get_allocator | ( |  | ) | const`[inline]`

Return copy of allocator used to construct this string.

Definition at line 1274 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

iterator __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::insert | ( | iterator | __p,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Insert one character.

Parameters:

  | p | Iterator referencing position in string to insert at.
  | c | The character to insert.

Returns:
  Iterator referencing newly inserted char.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts character c at position referenced by p. If adding character causes the length to exceed max_size(), length_error is thrown. If p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 861 of file vstring.h.

References _GLIBCXX_DEBUG_PEDASSERT.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::insert | ( | size_type | __pos,
|  | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Insert multiple characters.

Parameters:

  | pos | Index in string to insert at.
  | n | Number of characters to insert
  | c | The character to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos is beyond the end of this string.

Inserts n copies of character c starting at index pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos > length(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 844 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::insert | ( | size_type | __pos,
|  | const _CharT * | __s |
| ) |  |  | `[inline]`

Insert a C string.

Parameters:

  | pos | Iterator referencing location in string to insert at.
  | s | The C string to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos is beyond the end of this string.

Inserts the first n characters of s starting at pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 820 of file vstring.h.

References __glibcxx_requires_string, and std::replace().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::insert | ( | size_type | __pos,
|  | const _CharT * | __s,
|  | size_type | __n |
| ) |  |  | `[inline]`

Insert a C substring.

Parameters:

  | pos | Iterator referencing location in string to insert at.
  | s | The C string to insert.
  | n | The number of characters to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos is beyond the end of this string.

Inserts the first n characters of s starting at pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 801 of file vstring.h.

References std::replace().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::insert | ( | size_type | __pos1,
|  | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos2,
|  | size_type | __n |
| ) |  |  | `[inline]`

Insert a substring.

Parameters:

  | pos1 | Iterator referencing location in string to insert at.
  | str | The string to insert.
  | pos2 | Start of characters in str to insert.
  | n | Number of characters to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos1 > size() or pos2 > str.size().

Starting at pos1, insert n character of str beginning with pos2. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos1 is beyond the end of this string or pos2 is beyond the end of str, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 778 of file vstring.h.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::_M_check(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::_M_limit(), and std::replace().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::insert | ( | size_type | __pos1,
|  | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str |
| ) |  |  | `[inline]`

Insert value of a string.

Parameters:

  | pos1 | Iterator referencing location in string to insert at.
  | str | The string to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts value of str starting at pos1. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 755 of file vstring.h.

References std::replace(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>
template<class _InputIterator>

void __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::insert | ( | iterator | __p,
|  | _InputIterator | __beg,
|  | _InputIterator | __end |
| ) |  |  | `[inline]`

Insert a range of characters.

Parameters:

  | p | Iterator referencing location in string to insert at.
  | beg | Start of range.
  | end | End of range.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts characters in range [beg,end). If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 740 of file vstring.h.

References std::replace().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

void __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::insert | ( | iterator | __p,
|  | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Insert multiple characters.

Parameters:

  | p | Iterator referencing location in string to insert at.
  | n | Number of characters to insert
  | c | The character to insert.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts n copies of character c starting at the position referenced by iterator p. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 724 of file vstring.h.

References std::replace().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::length | ( |  | ) | const`[inline]`

null-termination.

Definition at line 341 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::max_size | ( |  | ) | const`[inline]`

Returns the size() of the largest possible string.

Definition at line 346 of file vstring.h.

Referenced by std::getline().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::operator+= | ( | _CharT | __c | ) | `[inline]`

Append a character.

Parameters:

  | c | The character to append.

Returns:
  Reference to this string.

Definition at line 521 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::operator+= | ( | const _CharT * | __s | ) | `[inline]`

Append a C string.

Parameters:

  | s | The C string to append.

Returns:
  Reference to this string.

Definition at line 512 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::operator+= | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str | ) | `[inline]`

Append a string to this string.

Parameters:

  | str | The string to append.

Returns:
  Reference to this string.

Definition at line 503 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::operator= | ( | _CharT | __c | ) | `[inline]`

Set value to string of length 1.

Parameters:

  | c | Source character.

Assigning to a character makes this string length 1 and (*this)[0] == c.

Definition at line 249 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::operator= | ( | const _CharT * | __s | ) | `[inline]`

Copy contents of s into this string.

Parameters:

  | s | Source null-terminated string.

Definition at line 238 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::operator= | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str | ) | `[inline]`

Assign the value of str to this string.

Parameters:

  | str | Source string.

Definition at line 230 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

reference __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::operator[] | ( | size_type | __pos | ) | `[inline]`

Subscript access to the data contained in the string.

Parameters:

  | pos | The index of the character to access.

Returns:
  Read/write reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().) Unshares the string.

Definition at line 448 of file vstring.h.

References _GLIBCXX_DEBUG_ASSERT, and _GLIBCXX_DEBUG_PEDASSERT.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

const_reference __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::operator[] | ( | size_type | __pos | ) | const`[inline]`

Subscript access to the data contained in the string.

Parameters:

  | pos | The index of the character to access.

Returns:
  Read-only (constant) reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 431 of file vstring.h.

References _GLIBCXX_DEBUG_ASSERT.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

void __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::push_back | ( | _CharT | __c | ) | `[inline]`

Append a single character.

Parameters:

  | c | Character to append.

Definition at line 612 of file vstring.h.

Referenced by __gnu_cxx::operator+().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

const_reverse_iterator __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::rbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to the last character in the string. Iteration is done in reverse element order.

Definition at line 309 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

reverse_iterator __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::rbegin | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to the last character in the string. Iteration is done in reverse element order. Unshares the string.

Definition at line 300 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

const_reverse_iterator __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::rend | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order.

Definition at line 327 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

reverse_iterator __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::rend | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order. Unshares the string.

Definition at line 318 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>
template<class _InputIterator>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | _InputIterator | __k1,
|  | _InputIterator | __k2 |
| ) |  |  | `[inline]`

Replace range of characters with range.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | k1 | Iterator referencing start of range to insert.
  | k2 | Iterator referencing end of range to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, characters in the range [k1,k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1145 of file vstring.h.

References __glibcxx_requires_valid_range, and _GLIBCXX_DEBUG_PEDASSERT.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Replace range of characters with multiple characters.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | n | Number of characters to insert.
  | c | Character to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, n copies of c are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1122 of file vstring.h.

References _GLIBCXX_DEBUG_PEDASSERT.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s |
| ) |  |  | `[inline]`

Replace range of characters with C string.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | s | C string value to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, the characters of s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1101 of file vstring.h.

References __glibcxx_requires_string, and std::replace().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s,
|  | size_type | __n |
| ) |  |  | `[inline]`

Replace range of characters with C substring.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | s | C string value to insert.
  | n | Number of characters from s to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, the first n characters of s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1080 of file vstring.h.

References _GLIBCXX_DEBUG_PEDASSERT, and std::replace().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str |
| ) |  |  | `[inline]`

Replace range of characters with string.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | str | String value to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, the value of str is inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1062 of file vstring.h.

References std::replace(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | size_type | __n2,
|  | _CharT | __c |
| ) |  |  | `[inline]`

Replace characters with multiple characters.

Parameters:

  | pos | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | n2 | Number of characters to insert.
  | c | Character to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos > size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, n2 copies of c are inserted. If pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1044 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s |
| ) |  |  | `[inline]`

Replace characters with value of a C string.

Parameters:

  | pos | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | s | C string to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos > size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, the first n characters of s are inserted. If pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1021 of file vstring.h.

References __glibcxx_requires_string, and std::replace().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 |
| ) |  |  | `[inline]`

Replace characters with value of a C substring.

Parameters:

  | pos | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | s | C string to insert.
  | n2 | Number of characters from s to use.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos1 > size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, the first n2 characters of s are inserted, or all of s if n2 is too large. If pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 997 of file vstring.h.

References __glibcxx_requires_string_len.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::replace | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 |
| ) |  |  | `[inline]`

Replace characters with value from another string.

Parameters:

  | pos1 | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | str | String to insert.
  | pos2 | Index of first character of str to use.
  | n2 | Number of characters from str to use.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos1 > size() or pos2 > str.size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos1,pos1 + n) from this string. In place, the value of str is inserted. If pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 970 of file vstring.h.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::_M_check(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::_M_limit(), and std::replace().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string& __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::replace | ( | size_type | __pos,
|  | size_type | __n,
|  | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str |
| ) |  |  | `[inline]`

Replace characters with value from another string.

Parameters:

  | pos | Index of first character to replace.
  | n | Number of characters to be replaced.
  | str | String to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos is beyond the end of this string.
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos+n) from this string. In place, the value of str is inserted. If pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 948 of file vstring.h.

References std::replace(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

void __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::reserve | ( | size_type | __res_arg = `0` | ) | `[inline]`

Attempt to preallocate enough memory for specified number of characters.

Parameters:

  | res_arg | Number of characters required.

Exceptions:

  | std::length_error | If res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

Definition at line 402 of file vstring.h.

Referenced by __gnu_cxx::operator+().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

void __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::resize | ( | size_type | __n | ) | `[inline]`

Resizes the string to the specified number of characters.

Parameters:

  | n | Number of characters the string should contain.

This function will resize the string to the specified length. If the new size is smaller than the string's current size the string is truncated, otherwise the string is extended and new characters are default-constructed. For basic types such as char, this means setting them to 0.

Definition at line 373 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

void __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::resize | ( | size_type | __n,
|  | _CharT | __c |
| ) |  |  |

Resizes the string to the specified number of characters.

Parameters:

  | n | Number of characters the string should contain.
  | c | Character to fill any new elements.

This function will resize the string to the specified number of characters. If the number is smaller than the string's current size the string is truncated, otherwise the string is extended and new elements are set to c.

Definition at line 52 of file vstring.tcc.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string< _CharT, _Traits, _Alloc, _Base >::size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::rfind | ( | _CharT | __c,
|  | size_type | __pos = `npos` |
| ) |  |  | const

Find last position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for c within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 336 of file vstring.tcc.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::npos, and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a C string.

Parameters:

  | s | C string to locate.
  | pos | Index of character to start search at (default end).

Returns:
  Index of start of last occurrence.

Starting from pos, searches backward for the value of s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1374 of file vstring.h.

References __glibcxx_requires_string.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string< _CharT, _Traits, _Alloc, _Base >::size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const

Find last position of a C substring.

Parameters:

  | s | C string to locate.
  | pos | Index of character to search back from.
  | n | Number of characters from s to search for.

Returns:
  Index of start of last occurrence.

Starting from pos, searches backward for the first n characters in s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 314 of file vstring.tcc.

References __glibcxx_requires_string_len, std::min(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::npos, and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::rfind | ( | const __versa_string< _CharT, _Traits, _Alloc, _Base > & | __str,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline]`

Find last position of a string.

Parameters:

  | str | String to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of start of last occurrence.

Starting from pos, searches backward for value of str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1346 of file vstring.h.

References __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::data(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::size | ( |  | ) | const`[inline]`

null-termination.

Definition at line 335 of file vstring.h.

Referenced by __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::append(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::compare(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_not_of(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_of(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_not_of(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_of(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::insert(), __gnu_cxx::operator+(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::replace(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::rfind().

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

__versa_string __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::substr | ( | size_type | __pos = `0`,
|  | size_type | __n = `npos` |
| ) |  |  | const`[inline]`

Get a substring.

Parameters:

  | pos | Index of first character (default 0).
  | n | Number of characters in substring (default remainder).

Returns:
  The new string.

Exceptions:

  | std::out_of_range | If pos > size().

Construct and return a new string using the n characters starting at pos. If the string is too short, use the remainder of the characters. If pos is beyond the end of the string, out_of_range is thrown.

Definition at line 1647 of file vstring.h.

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

void __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::swap | ( | __versa_string< _CharT, _Traits, _Alloc, _Base > & | __s | ) | `[inline]`

Swap contents with another string.

Parameters:

  | s | String to swap with.

Exchanges the contents of this string with that of s in constant time.

Definition at line 1246 of file vstring.h.

Referenced by __gnu_cxx::swap().

## Member Data Documentation

template<typename _CharT, typename _Traits, typename _Alloc, template< typename, typename, typename > class _Base>

const __versa_string< _CharT, _Traits, _Alloc, _Base >::size_type __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::npos `[static]`

Value returned by various member functions when they fail.

Definition at line 78 of file vstring.h.

Referenced by __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_not_of(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_first_of(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_not_of(), __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::find_last_of(), and __gnu_cxx::__versa_string< _CharT, _Traits, _Alloc, _Base >::rfind().

The documentation for this class was generated from the following files:

- vstring.h
- vstring.tcc